import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

get xcolor_BackGround => Colors.black;
get xcolor_Foreground => Colors.white;
get xcolor_HomePage => Colors.blue[700];
get xcolor_BackGroundTitleContainer => Colors.transparent;
get xcolor_BackGroundTreeNode => Colors.grey[900];
get xcolor_BackGroundTitleContainerForScheda => Colors.grey[400]!;
get xcolor_BackGroundTitleContainerForElenco => Colors.grey[400]!;

class XfxScheda extends StatefulWidget {
  XfxScheda({
    Key? key,
    this.titleScheda = "",
    this.visibleXContainerWithLabelOnTop = true,
    this.child,
    this.listOfChildren,
    this.bottomNavigationBarvisible = true,
    this.onTapOnBTNofMenu,
    this.currentIndexOfBottomMenu,
    required this.childrenOfBottomBar,
  }) : super(key: key);
  final String titleScheda;
  final bool visibleXContainerWithLabelOnTop;
  final Widget? child;
  final Function(int)? onTapOnBTNofMenu;
  final List<Widget>? listOfChildren;
  final bool? bottomNavigationBarvisible;
  final int? currentIndexOfBottomMenu;

  List<BottomNavigationBarItem> childrenOfBottomBar;
  @override
  _XfxSchedaState createState() => _XfxSchedaState();
}

class _XfxSchedaState extends State<XfxScheda> {
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
        onTap: () {},
        child: Scaffold(
            backgroundColor: xcolor_BackGround,
            body: Container(
                margin: EdgeInsets.symmetric(horizontal: 15),
                child: Column(children: [
                  SizedBox(height: 10),
                  widget.visibleXContainerWithLabelOnTop == true
                      ? Row(
                          children: [
                            Expanded(child: XContainerWithLabel(widget.titleScheda, height: 30, color: xcolor_BackGroundTitleContainerForScheda, textStyle: TextStyle(fontSize: 18, color: Colors.black))),
                          ],
                        )
                      : Container(),
                  SizedBox(height: 3),
                  SingleChildScrollView(
                    child: Container(
                      child: widget.child ?? Container(),
                    ),
                  ),
                  SizedBox(height: 5),
                ])),
            bottomNavigationBar: widget.bottomNavigationBarvisible == true
                ? BottomNavigationBar(
                    type: BottomNavigationBarType.fixed,
                    currentIndex: widget.currentIndexOfBottomMenu ?? 0,
                    onTap: widget.onTapOnBTNofMenu,
                    enableFeedback: true,
                    showUnselectedLabels: true,
                    selectedItemColor: Colors.blue[700],
                    selectedFontSize: 15,
                    selectedLabelStyle: TextStyle(fontSize: 10),
                    backgroundColor: Colors.grey[900],
                    unselectedItemColor: xcolor_Foreground,
                    unselectedFontSize: 10,
                    unselectedLabelStyle: TextStyle(fontSize: 10),
                    iconSize: 20,
                    items: widget.childrenOfBottomBar)
                : Container(
                    height: 1,
                  )));
  }
}

class XfxSchedaTabbed extends StatefulWidget {
  XfxSchedaTabbed({
    Key? key,
    this.titleScheda = "",
    this.visibleXContainerWithLabelOnTop = true,
    this.listOfChildren,
    this.childrenOfTabViewer,
    this.numberOfTabs,
    this.tabs,
    this.bottomNavigationBarvisible = true,
    this.isScrollableTabs = false,
    this.onTapOnBTNofMenu,
    this.currentIndexOfBottomMenu,
    this.backgroundColorTabs,
    required this.childrenOfBottomBar,
  }) : super(key: key);
  final String titleScheda;
  final bool visibleXContainerWithLabelOnTop;
  final List<Widget>? listOfChildren;
  final List<Widget>? childrenOfTabViewer;
  final int? numberOfTabs;
  final bool? bottomNavigationBarvisible;
  final List<Widget>? tabs;
  final bool? isScrollableTabs;
  final int? currentIndexOfBottomMenu;
  final Function(int)? onTapOnBTNofMenu;
  List<BottomNavigationBarItem> childrenOfBottomBar;
  final Color? backgroundColorTabs;
  @override
  _XfxSchedaTabbedState createState() => _XfxSchedaTabbedState();
}

tabViewerPagesSch(String titleScheda, Widget? childOfSchedaTabViewer, List<BottomNavigationBarItem> childrenOfBottomBar) {
  return XfxScheda(bottomNavigationBarvisible: false, titleScheda: titleScheda, child: childOfSchedaTabViewer, childrenOfBottomBar: childrenOfBottomBar);
}

templateSchedaViewerSch(
  String subTitle,
  String descr,
) {
  return Column(
    children: [
      SizedBox(height: 5),
      XContainerWithLabel(
        subTitle,
        color: xcolor_BackGround,
        alignmentContainer: Alignment.centerLeft,
        textStyle: TextStyle(color: xcolor_Foreground, fontSize: 20),
      ),
      SizedBox(height: 5),
      XContainerWithLabel(
        descr,
        color: xcolor_BackGround,
        alignmentContainer: Alignment.centerLeft,
        textAlignment: TextAlign.left,
        textStyle: TextStyle(color: xcolor_Foreground, fontSize: 20),
      ),
    ],
  );
}

tabPagesSch(IconData icon, String? label) {
  return Tab(icon: Icon(icon, color: Colors.white), child: Text(label ?? ""));
}

class _XfxSchedaTabbedState extends State<XfxSchedaTabbed> {
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
        onTap: () {},
        child: DefaultTabController(
            length: widget.numberOfTabs!,
            child: Scaffold(
                backgroundColor: xcolor_BackGround,
                body: Container(
                    margin: EdgeInsets.symmetric(horizontal: 15),
                    child: Column(children: [
                      widget.visibleXContainerWithLabelOnTop == true ? SizedBox(height: 10) : SizedBox(height: 0),
                      widget.visibleXContainerWithLabelOnTop == true
                          ? Row(
                              children: [
                                Expanded(child: XContainerWithLabel(widget.titleScheda, height: 30, color: xcolor_BackGroundTitleContainerForScheda, textStyle: TextStyle(fontSize: 18, color: Colors.black))),
                              ],
                            )
                          : Container(),
                      widget.visibleXContainerWithLabelOnTop == true ? SizedBox(height: 3) : SizedBox(height: 0),
                      TabBar(
                        indicator: BoxDecoration(color: widget.backgroundColorTabs ?? Colors.white),
                        isScrollable: widget.isScrollableTabs!,
                        tabs: widget.tabs!,
                      ),
                      SizedBox(height: 3),
                      Expanded(
                        child: Container(
                          child: TabBarView(children: widget.childrenOfTabViewer!),
                        ),
                      ),
                      SizedBox(height: 5),
                    ])),
                bottomNavigationBar: widget.bottomNavigationBarvisible == true
                    ? BottomNavigationBar(
                        type: BottomNavigationBarType.fixed,
                        currentIndex: widget.currentIndexOfBottomMenu ?? 0,
                        onTap: widget.onTapOnBTNofMenu,
                        enableFeedback: true,
                        showUnselectedLabels: true,
                        selectedItemColor: Colors.blue[700],
                        selectedFontSize: 15,
                        selectedLabelStyle: TextStyle(fontSize: 10),
                        backgroundColor: Colors.grey[900],
                        unselectedItemColor: xcolor_Foreground,
                        unselectedFontSize: 10,
                        unselectedLabelStyle: TextStyle(fontSize: 10),
                        iconSize: 20,
                        items: widget.childrenOfBottomBar)
                    : Container(
                        height: 1,
                      ))));
  }
}

class XCheckBoxWidget extends StatelessWidget {
  late final String labelCheckBox;
  final Color? colorTitle;
  late final bool valueCheckBox;
  final Function(bool?)? onChangedCheckBox;
  late final bool verticalCheckBoxWidget;
  final Function()? onTap;
  final TextStyle? styleLabel;
  final Color? checkColor;
  final bool? labelOnBottom;
  XCheckBoxWidget({
    this.labelCheckBox = "",
    this.colorTitle,
    this.styleLabel,
    this.checkColor,
    this.valueCheckBox = false,
    this.onChangedCheckBox,
    this.verticalCheckBoxWidget = false,
    this.onTap,
    this.labelOnBottom = false,
  });

  @override
  Widget build(BuildContext context) {
    return Container(
      child: verticalCheckBoxWidget == false
          ? Row(children: [
              GestureDetector(onTap: onTap, child: Text(labelCheckBox, textAlign: TextAlign.center, style: styleLabel ?? TextStyle(color: colorTitle ?? xcolor_Foreground))),
              Container(width: 30, height: 30, child: Checkbox(fillColor: MaterialStateProperty.all(xcolor_Foreground), value: valueCheckBox, checkColor: checkColor ?? xcolor_BackGround, onChanged: onChangedCheckBox)),
            ])
          : Column(
              children: [
                labelOnBottom == false
                    ? Row(children: [
                        GestureDetector(onTap: onTap, child: Text(labelCheckBox, textAlign: TextAlign.center, style: styleLabel ?? TextStyle(color: colorTitle ?? xcolor_Foreground))),
                      ])
                    : Container(height: 1),
                Row(
                  children: [
                    Container(
                        width: 30,
                        height: 30,
                        child: Checkbox(
                          fillColor: MaterialStateProperty.all(xcolor_Foreground),
                          value: valueCheckBox,
                          checkColor: xcolor_BackGround,
                          onChanged: onChangedCheckBox,
                        ))
                  ],
                ),
                labelOnBottom == true
                    ? Row(children: [
                        GestureDetector(onTap: onTap, child: Text(labelCheckBox, textAlign: TextAlign.center, style: styleLabel ?? TextStyle(color: colorTitle ?? xcolor_Foreground))),
                      ])
                    : Container(height: 1),
              ],
            ),
    );
  }
}

class XContainerWithLabel extends StatelessWidget {
  final String? label;
  final Color? color;
  final TextStyle? textStyle;
  final double? height;
  final AlignmentGeometry? alignmentContainer;
  final TextAlign? textAlignment;
  final EdgeInsetsGeometry? margin;
  final double? maxwidth;
  XContainerWithLabel(
    this.label, {
    this.height,
    this.alignmentContainer,
    this.textAlignment,
    this.maxwidth,
    this.margin,
    this.color = Colors.white,
    this.textStyle,
  });

  TextStyle styTextBaseBlack([Color? textColor]) {
    if (textColor == null) textColor = Colors.black;
    return TextStyle(fontSize: 14, color: textColor);
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      margin: margin ?? EdgeInsets.only(right: 0),
      height: height,
      color: color,
      width: maxwidth,
      alignment: alignmentContainer ?? Alignment.center,
      child: Text(label ?? " ", style: textStyle ?? styTextBaseBlack(), textAlign: textAlignment ?? TextAlign.center),
    );
  }
}

class XTextFormField extends StatelessWidget {
  final String? label;
  final String hintText;
  final IconData? icon;
  final ValueChanged<String>? onChanged;
  final ValueChanged<String?>? onChangedDropDown;
  final TextInputType keyboardType;
  final Function? onFieldSubmitted;
  final Function? onSaved;
  final Function? onPressed;
  final Function? validator;
  final Function? onEditingComplete;
  final FocusNode? focusNode;
  final bool isPassword;
  final bool multiLines;
  final bool isVisible;
  final bool isVisibleDropDown;
  final bool showSearchBox;
  final double? width;
  final double maxHeight;
  final int? maxLines;
  final double? height;
  final TextInputAction textInputAction;
  final TextEditingController? controller;
  final AutovalidateMode? autovalidateMode;
  final String? initialValue;
  final TextStyle? labelStyle;
  GestureTapCallback? onTap;
  final List<String>? items;
  List<TextInputFormatter>? inputFormatters;
  final Color? textColor;
  final FloatingLabelBehavior? floatingLabelBehaviorActive;
  final InputBorder? border;
  final InputBorder? disabledBorder;
  final InputBorder? enabledBorder;
  final TextStyle? hintStyle;
  final EdgeInsetsGeometry? contentPadding;
  final Widget? suffixIcon;
  final bool? isDenseTextFormField;
  XTextFormField(
      {this.label,
      this.hintText = '',
      this.icon,
      this.border,
      this.suffixIcon,
      this.contentPadding,
      this.isDenseTextFormField = true,
      this.enabledBorder,
      this.disabledBorder,
      this.floatingLabelBehaviorActive,
      this.hintStyle,
      this.labelStyle,
      this.onEditingComplete,
      this.initialValue,
      this.items,
      this.inputFormatters,
      this.isVisible = false,
      this.isVisibleDropDown = false,
      this.controller,
      this.onPressed,
      this.width,
      this.textColor,
      this.onTap,
      this.maxLines,
      this.height,
      this.maxHeight = 500,
      this.showSearchBox = false,
      this.onChanged,
      this.onChangedDropDown,
      this.multiLines = false,
      this.keyboardType = TextInputType.text,
      this.textInputAction = TextInputAction.next,
      this.onFieldSubmitted,
      this.onSaved,
      this.validator,
      this.focusNode,
      this.autovalidateMode,
      this.isPassword = false});

  @override
  Widget build(BuildContext context) {
    return Container(
      child: Stack(
        alignment: Alignment.bottomRight,
        children: <Widget>[
          Column(children: <Widget>[
            Container(
              width: width,
              height: height,
              child: TextFormField(
                  initialValue: initialValue,
                  controller: controller,
                  onTap: onTap,
                  focusNode: focusNode,
                  keyboardType: (multiLines ? TextInputType.multiline : keyboardType),
                  style: labelStyle ?? TextStyle(color: textColor ?? Colors.white),
                  textInputAction: (multiLines ? TextInputAction.newline : textInputAction),
                  onFieldSubmitted: onFieldSubmitted as void Function(String)?,
                  obscureText: isPassword,
                  strutStyle: StrutStyle(height: height, forceStrutHeight: true),
                  onSaved: onSaved as void Function(String?)?,
                  onEditingComplete: onEditingComplete as void Function()?,
                  onChanged: onChanged,
                  inputFormatters: inputFormatters ?? [],
                  maxLines: maxLines,
                  autovalidateMode: autovalidateMode,
                  validator: validator as String? Function(String?)?,
                  decoration: InputDecoration(
                    isDense: isDenseTextFormField,
                    floatingLabelBehavior: floatingLabelBehaviorActive ?? FloatingLabelBehavior.always,
                    contentPadding: contentPadding ?? EdgeInsets.only(top: 20, left: 5, bottom: 1),
                    border: border ?? OutlineInputBorder(borderRadius: BorderRadius.all(Radius.circular(4.0)), borderSide: BorderSide(width: 1, color: Colors.white), gapPadding: 3),
                    disabledBorder: disabledBorder ?? OutlineInputBorder(borderRadius: BorderRadius.all(Radius.circular(4.0)), borderSide: BorderSide(width: 1, color: Colors.white), gapPadding: 3),
                    enabledBorder: enabledBorder ?? OutlineInputBorder(borderRadius: BorderRadius.all(Radius.circular(4.0)), borderSide: BorderSide(width: 1, color: Colors.white), gapPadding: 3),
                    labelText: label,
                    suffixIcon: suffixIcon,
                    hintText: hintText,
                    labelStyle: labelStyle,
                    hintStyle: hintStyle ??
                        TextStyle(
                          color: textColor ?? Colors.white,
                        ),
                  )),
            ),
            isVisibleDropDown != false
                ? SizedBox(
                    height: 5,
                  )
                : Container(),
          ]),
          isVisible == true
              ? Container(
                  alignment: Alignment.bottomRight,
                  height: 40,
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.end,
                    crossAxisAlignment: CrossAxisAlignment.end,
                    children: <Widget>[
                      Container(
                          padding: EdgeInsets.fromLTRB(0, 0, 0, 5),
                          child: ElevatedButton(
                            style: ElevatedButton.styleFrom(
                              elevation: 1,
                              primary: Colors.transparent,
                            ),
                            onPressed: onPressed as void Function()?,
                            child: Icon(
                              Icons.done,
                              color: Colors.greenAccent,
                            ),
                          )),
                      SizedBox(
                        width: 5,
                      ),
                    ],
                  ),
                )
              : Container()
        ],
      ),
    );
  }
}

class XTextFormFieldLogin extends StatelessWidget {
  final String? label;
  final String? hintText;
  final String? initialValue;
  final IconData? icon;
  final Decoration? decoration;
  final ValueChanged<String>? onChanged;
  final TextInputType keyboardType;
  final Function? onFieldSubmitted;
  final Function? onSaved;
  final Function? validator;
  final bool obscureText;
  final bool visible;
  final FocusNode? focusNode;
  final double width;
  final Widget? suffixIcon;
  final TextInputAction textInputAction;
  final TextEditingController? controller;
  final String obscuringCharacter = '•';
  final TextStyle? hintStyle;
  final TextStyle? styleText;
  final Color? borderColor;
  final Color? colorIcon;
  XTextFormFieldLogin(
      {this.label,
      this.borderColor,
      this.colorIcon,
      this.hintText,
      this.hintStyle,
      this.styleText,
      this.icon,
      this.controller,
      this.visible = false,
      this.decoration,
      this.suffixIcon,
      this.onChanged,
      this.width = 300,
      this.keyboardType = TextInputType.text,
      this.textInputAction = TextInputAction.next,
      this.onFieldSubmitted,
      this.onSaved,
      this.initialValue,
      this.validator,
      this.focusNode,
      this.obscureText = false});

  xLabelStyle() {
    return TextStyle(color: Colors.black, fontFamily: 'OpenSans', fontSize: 12);
  }

  xBoxDecorationStyle(Color? color) {
    return BoxDecoration(
        border: Border.all(
          color: color ?? Colors.white,
          width: 1,
        ),
        borderRadius: BorderRadius.all(Radius.circular(10)));
  }

  @override
  Widget build(BuildContext context) {
    return Column(crossAxisAlignment: CrossAxisAlignment.start, children: <Widget>[
      Text(label ?? "", style: xLabelStyle()),
      Container(
        width: width,
        decoration: xBoxDecorationStyle(borderColor ?? Colors.white),
        child: TextFormField(
          focusNode: focusNode,
          keyboardType: keyboardType,
          style: styleText ?? TextStyle(color: Colors.white),
          textInputAction: textInputAction,
          onFieldSubmitted: onFieldSubmitted as void Function(String)?,
          obscureText: obscureText,
          onSaved: onSaved as void Function(String?)?,
          obscuringCharacter: obscuringCharacter,
          controller: controller,
          onChanged: onChanged,
          maxLines: 1,
          initialValue: initialValue,
          validator: validator as String? Function(String?)?,
          decoration: InputDecoration(
            border: InputBorder.none,
            prefixIcon: Icon(icon, color: colorIcon ?? Colors.white),
            hintText: hintText ?? "",
            hintStyle: hintStyle ?? TextStyle(color: colorIcon ?? Colors.white, fontSize: 20),
            suffixIcon: Container(width: 20, child: suffixIcon),
          ),
        ),
      ),
    ]);
  }
}

class XTextFormFieldWithLabel extends StatelessWidget {
  final String? label;
  final IconData? icon;
  final TextAlignVertical? textAlignVertical;
  final ValueChanged<String>? onChanged;
  final Function()? onPressed;
  final FocusNode? focusNode;
  final String? initialValue;
  final TextInputType? keyboardType;
  final TextEditingController? controller;
  final Function(String)? onFieldSubmitted;
  final String? hintText;
  final EdgeInsets? marginContainerText;
  VoidCallback? onEditingComplete;
  List<TextInputFormatter>? inputFormatters;
  InputDecoration? decoration = const InputDecoration();
  FormFieldValidator<String>? validator;
  AutovalidateMode? autovalidateMode;
  bool? autovalidate = false;
  GestureTapCallback? onTap;
  bool? expands = false;
  int? maxLines = 1;
  final int? minLines;
  TextAlign? textAlign = TextAlign.start;
  Alignment? alignmentLabel = Alignment.center;
  final Alignment? alignment;
  CrossAxisAlignment? crossAxisAlignment = CrossAxisAlignment.center;
  final Color? colorBorder;
  final bool? readOnlyFormField;
  final TextStyle? textStyle;
  final TextStyle? hintStyle;
  final int? flexLabelContainer;
  final int? flexTextContainer;
  final TextStyle? labelStyle;

  XTextFormFieldWithLabel({
    this.crossAxisAlignment,
    this.label = "",
    this.marginContainerText,
    this.controller,
    this.labelStyle,
    this.textStyle,
    this.hintStyle,
    this.textAlign,
    this.flexTextContainer,
    this.colorBorder,
    this.readOnlyFormField = false,
    this.alignment,
    this.onEditingComplete,
    this.onTap,
    this.textAlignVertical,
    this.alignmentLabel,
    this.icon,
    this.validator,
    this.autovalidateMode,
    this.onChanged,
    this.autovalidate,
    this.inputFormatters,
    this.decoration,
    this.minLines,
    this.maxLines,
    this.expands = false,
    this.onPressed,
    this.keyboardType,
    this.initialValue = "",
    this.focusNode,
    this.flexLabelContainer,
    this.onFieldSubmitted,
    this.hintText = '',
  })  : assert(maxLines == null || maxLines > 0),
        assert(expands != null),
        assert(
          !expands! || (maxLines == null && minLines == null),
          'minLines e MxLines devono essere null quando expands è true.',
        );
  @override
  Widget build(BuildContext context) {
    return Row(
      crossAxisAlignment: crossAxisAlignment ?? CrossAxisAlignment.center,
      mainAxisAlignment: MainAxisAlignment.center,
      children: <Widget>[
        SizedBox(width: 5),
        Visibility(
          visible: label != "",
          child: Expanded(
            flex: flexLabelContainer ?? 1,
            child: Container(
              alignment: alignmentLabel,
              child: Text(
                label!,
                style: labelStyle ?? Theme.of(context).textTheme.caption,
              ),
            ),
          ),
        ),
        Expanded(
          flex: flexTextContainer ?? 4,
          child: Container(
            margin: marginContainerText ?? EdgeInsets.only(left: 5),
            child: readOnlyFormField == false
                ? FormField(
                    autovalidateMode: AutovalidateMode.onUserInteraction,
                    builder: (FormFieldState state) {
                      return TextFormField(
                        onEditingComplete: onEditingComplete,
                        onTap: onTap,
                        textAlign: textAlign ?? TextAlign.start,
                        controller: controller,
                        validator: validator,
                        autovalidateMode: autovalidateMode ?? AutovalidateMode.always,
                        maxLines: maxLines,
                        initialValue: initialValue,
                        onChanged: onChanged,
                        focusNode: focusNode ?? FocusNode(),
                        keyboardType: keyboardType ?? TextInputType.text,
                        inputFormatters: inputFormatters ?? [],
                        onFieldSubmitted: onFieldSubmitted!,
                        decoration: InputDecoration(
                          border: UnderlineInputBorder(borderSide: BorderSide(color: colorBorder ?? xcolor_Foreground, width: 4)),
                          hintText: hintText,
                          hintStyle: hintStyle,
                        ),
                      );
                    },
                  )
                : Text(
                    initialValue ?? "",
                    style: textStyle,
                    textAlign: textAlign ?? TextAlign.start,
                    maxLines: maxLines,
                  ),
          ),
        ),
      ],
    );
  }
}

class XTreeNode extends StatefulWidget {
  final int? level;
  final bool? expaned;
  final double? offsetLeft;
  final List<Widget>? children;
  final Color colorIcon;
  final Color colorTreeNode;
  final EdgeInsets? paddingTreeNode;

  final Widget? title;
  final Widget? leading;
  final Widget? trailing;

  final Function? titleOnTap;
  final Function? leadingOnTap;
  final Function? trailingOnTap;

  const XTreeNode({
    this.colorIcon = Colors.white,
    this.colorTreeNode = Colors.black,
    this.paddingTreeNode,
    this.level = 0,
    this.expaned = false,
    this.offsetLeft = 24.0,
    this.children = const [],
    this.title = const Text('Title'),
    this.leading = const IconButton(
      icon: Icon(Icons.star_border, color: Colors.white),
      iconSize: 16,
      onPressed: null,
    ),
    this.trailing = const IconButton(
      icon: Icon(
        Icons.expand_more,
        color: Colors.white,
      ),
      iconSize: 16,
      onPressed: null,
    ),
    this.titleOnTap,
    this.leadingOnTap,
    this.trailingOnTap,
  });

  @override
  _TreeNodeState createState() => _TreeNodeState();
}

class _TreeNodeState extends State<XTreeNode> with SingleTickerProviderStateMixin {
  bool _isExpaned = false;

  AnimationController? _rotationController;
  final Tween<double> _turnsTween = Tween<double>(begin: 0.0, end: -0.5);

  initState() {
    _isExpaned = widget.expaned!;
    _rotationController = AnimationController(
      duration: const Duration(milliseconds: 300),
      vsync: this,
    );
    super.initState();
  }

  @override
  void dispose() {
    _rotationController!.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    final level = widget.level;
    final children = widget.children;
    final offsetLeft = widget.offsetLeft;
    final colorIcon = widget.colorIcon;
    final colorTreeNode = widget.colorTreeNode;
    final paddingTreeNode = widget.paddingTreeNode;
    return Column(
      crossAxisAlignment: CrossAxisAlignment.start,
      children: <Widget>[
        GestureDetector(
            onTap: () {
              if (widget.leadingOnTap != null && widget.leadingOnTap is Function) {
                widget.leadingOnTap!();
              }
            },
            child: Container(
                decoration: BoxDecoration(
                  borderRadius: BorderRadius.all(Radius.circular(10)),
                  color: colorTreeNode,
                ),
                child: Padding(
                  padding: paddingTreeNode ?? const EdgeInsets.only(left: 12.0, top: 5, bottom: 5),
                  child: Row(
                    crossAxisAlignment: CrossAxisAlignment.center,
                    children: <Widget>[
                      GestureDetector(
                        onTap: () {
                          setState(() {
                            _isExpaned = !_isExpaned;
                            if (_isExpaned) {
                              _rotationController!.forward();
                            } else {
                              _rotationController!.reverse();
                            }
                            if (widget.trailingOnTap != null && widget.trailingOnTap is Function) {
                              widget.trailingOnTap!();
                            }
                          });
                          if (widget.leadingOnTap != null && widget.leadingOnTap is Function) {
                            widget.leadingOnTap!();
                          }
                        },
                        child: Center(
                          child: widget.leading ??
                              IconButton(
                                icon: Icon(Icons.star_border),
                                iconSize: 16,
                                onPressed: null,
                                color: colorIcon,
                              ),
                        ),
                      ),
                      SizedBox(width: 6.0),
                      Expanded(
                        child: GestureDetector(
                          onTap: () {
                            setState(() {
                              _isExpaned = !_isExpaned;
                              if (_isExpaned) {
                                _rotationController!.forward();
                              } else {
                                _rotationController!.reverse();
                              }
                              if (widget.trailingOnTap != null && widget.trailingOnTap is Function) {
                                widget.trailingOnTap!();
                              }
                            });
                            if (widget.titleOnTap != null && widget.titleOnTap is Function) {
                              widget.titleOnTap!();
                            }
                          },
                          child: widget.title ?? Container(),
                        ),
                      ),
                      SizedBox(width: 6.0),
                      Visibility(
                        visible: children!.isNotEmpty,
                        child: Center(
                          child: GestureDetector(
                            onTap: () {
                              setState(() {
                                _isExpaned = !_isExpaned;
                                if (_isExpaned) {
                                  _rotationController!.forward();
                                } else {
                                  _rotationController!.reverse();
                                }
                                if (widget.trailingOnTap != null && widget.trailingOnTap is Function) {
                                  widget.trailingOnTap!();
                                }
                              });
                            },
                            child: RotationTransition(
                              child: widget.trailing ??
                                  IconButton(
                                    icon: Icon(Icons.expand_more),
                                    iconSize: 16,
                                    onPressed: null,
                                    color: colorIcon,
                                  ),
                              turns: _turnsTween.animate(_rotationController!),
                            ),
                          ),
                        ),
                      ),
                    ],
                  ),
                ))),
        Visibility(
          visible: children.isNotEmpty && _isExpaned,
          child: Padding(
            padding: EdgeInsets.only(left: level! + 1 * offsetLeft!),
            child: Column(
              children: widget.children!,
              crossAxisAlignment: CrossAxisAlignment.start,
            ),
          ),
        ),
      ],
    );
  }
}

class XBtnbase extends StatelessWidget {
  final String? label;
  final IconData? icon;
  final Function()? onPressed;
  final Decoration? decoration;
  final TextStyle? style;
  final Color? textColor;
  final Color? iconColor;
  final Color color;
  final Widget? child;
  final double? elevation;
  final EdgeInsetsGeometry? padding;
  final OutlinedBorder? shape;
  final double? iconSize;
  final double? iconContainerWidth;
  final double? iconContainerheight;
  final int? typeUI;
  XBtnbase({
    this.label = "",
    this.decoration,
    this.typeUI,
    this.iconContainerWidth,
    this.iconContainerheight,
    this.elevation,
    this.icon,
    this.style,
    this.iconSize,
    this.color = Colors.black,
    this.textColor,
    this.iconColor = Colors.black,
    this.onPressed,
    this.child,
    this.padding,
    this.shape,
  });

  TextStyle styTextBaseWhite([Color? textColor]) {
    return TextStyle(fontSize: 14, color: Colors.white);
  }

  TextStyle styText3() {
    var s = styTextBaseWhite();
    var s1 = TextStyle(fontSize: 13);
    return s.merge(s1);
  }

  TextStyle styText3Black([Color? textColor]) {
    if (textColor == null) textColor = Colors.black;
    var s = styText3();
    var s1 = TextStyle(color: textColor);
    return s.merge(s1);
  }

  Widget selectUI() {
    ////// se 1 il bottone contiene solo l'icona
    if (typeUI == 1) {
      return Container(
        alignment: Alignment.center,
        width: iconContainerWidth,
        height: iconContainerheight,
        // alignment: Alignment.center,
        child: Icon(
          icon,
          color: iconColor,
          size: iconSize,
        ),
      );
      ////// se 2 il bottone contiene solo la label
    } else if (typeUI == 2) {
      return Row(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [Expanded(child: Text(label ?? "", textAlign: TextAlign.center, style: style ?? styText3Black(textColor)))],
      );
      ////// se 3 il bottone contiene  label + icona
    } else {
      return Row(children: [
        Expanded(
            child: Container(
                child: Icon(
          icon,
          color: iconColor,
          size: iconSize,
        ))),
        SizedBox(
          width: 5,
        ),
        Expanded(flex: 3, child: Text(label ?? "", textAlign: TextAlign.center, style: style ?? styText3Black(textColor)))
      ]);
    }
  }

  @override
  Widget build(BuildContext context) {
    return Container(
        decoration: decoration ?? BoxDecoration(border: Border.all(width: 3.4, color: decoration == null ? color : Colors.teal[800]!)),
        child: ElevatedButton(
          style: ElevatedButton.styleFrom(
            elevation: elevation ?? 10,
            padding: EdgeInsets.all(5),
            primary: decoration == null ? color : Colors.transparent,
          ),
          onPressed: onPressed,
          child: selectUI(),
        ));
  }
}

class XCardForText extends StatelessWidget {
  final String? title;
  final String? description;
  final String? imageAssets;
  final double? width;
  final double? height;
  final bool? photoLeft;
  final double? heightPhoto;
  XCardForText({
    this.description,
    this.width,
    this.photoLeft,
    this.heightPhoto,
    this.height,
    this.imageAssets,
    this.title,
  });

  @override
  Widget build(BuildContext context) {
    return Expanded(
        child: Card(
            elevation: 22,
            color: Colors.white.withAlpha(200),
            child: photoLeft == true
                ? Row(
                    children: [
                      Expanded(
                          flex: 1,
                          child: Container(
                            height: heightPhoto,
                            margin: EdgeInsets.all(10),
                            child: Image.asset(
                              imageAssets!,
                              fit: BoxFit.fill,
                            ),
                          )),
                      SizedBox(width: 100),
                      Expanded(
                          flex: 2,
                          child: Column(
                            children: [
                              SizedBox(height: 10),
                              Text(
                                title!,
                                style: TextStyle(
                                  color: Colors.black,
                                  fontSize: 25,
                                ),
                                textAlign: TextAlign.justify,
                              ),
                              SizedBox(height: 10),
                              Container(
                                  margin: EdgeInsets.all(10),
                                  child: Text(
                                    description!,
                                    style: TextStyle(
                                      color: Colors.black,
                                      fontSize: 25,
                                    ),
                                    textAlign: TextAlign.justify,
                                  )),
                            ],
                          )),
                      SizedBox(width: 20),
                    ],
                  )
                : Row(
                    children: [
                      SizedBox(width: 20),
                      Expanded(
                          flex: 2,
                          child: Column(
                            children: [
                              SizedBox(height: 10),
                              Text(
                                title!,
                                style: TextStyle(
                                  color: Colors.black,
                                  fontSize: 25,
                                ),
                              ),
                              SizedBox(height: 10),
                              Container(
                                  margin: EdgeInsets.all(10),
                                  child: Text(
                                    description!,
                                    style: TextStyle(
                                      color: Colors.black,
                                      fontSize: 25,
                                    ),
                                  )),
                            ],
                          )),
                      SizedBox(width: 100),
                      Expanded(
                          flex: 1,
                          child: Container(
                            height: heightPhoto,
                            margin: EdgeInsets.all(10),
                            child: Image.asset(
                              imageAssets!,
                              fit: BoxFit.fill,
                            ),
                          )),
                    ],
                  )));
  }
}

InputBorder? borderStyle() {
  return UnderlineInputBorder(borderRadius: BorderRadius.all(Radius.circular(4.0)), borderSide: BorderSide(width: 1, color: Colors.white));
}

class XColFilter extends StatefulWidget {
  XColFilter({
    Key? key,
    this.heightFilter,
    this.colorBackgroundFilter,
    this.propName,
    this.hintTextOfFilter,
    this.onChangedFilter,
    this.onPressedFilterSearch,
    this.colorBorderOfFilter,
  }) : super(key: key);
  final Color? colorBackgroundFilter;
  final double? heightFilter;
  final String? propName;
  final String? hintTextOfFilter;
  final Function(String)? onChangedFilter;
  final Function()? onPressedFilterSearch;
  final Color? colorBorderOfFilter;
  @override
  _XColFilterState createState() => _XColFilterState();
}

class _XColFilterState extends State<XColFilter> {
  String? initialValue = "";

  @override
  void initState() {
    super.initState();
  }

  sortString(dynamic a, dynamic b, String propName) {
    var resData = a.getProp(propName).compareTo(b.getProp(propName));
    return resData;
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
        onTap: () {
          setState(() {});
        },
        child: Container(
            decoration: BoxDecoration(border: Border.all(width: 1, color: widget.colorBorderOfFilter ?? xcolor_Foreground), color: widget.colorBackgroundFilter),
            child: Row(
              crossAxisAlignment: CrossAxisAlignment.end,
              children: [
                Expanded(
                    child: Container(
                        color: widget.colorBackgroundFilter,
                        height: widget.heightFilter ?? 35,
                        child: XTextFormField(
                            onChanged: widget.onChangedFilter,
                            contentPadding: EdgeInsets.only(top: 10, left: 5, bottom: 1),
                            height: 32,
                            hintStyle: TextStyle(color: widget.colorBorderOfFilter ?? xcolor_Foreground),
                            initialValue: initialValue,
                            border: borderStyle(),
                            maxLines: 1,
                            multiLines: false,
                            disabledBorder: borderStyle(),
                            enabledBorder: borderStyle(),
                            hintText: widget.hintTextOfFilter ?? "",
                            suffixIcon: IconButton(icon: Icon(Icons.search, size: 20, color: widget.colorBorderOfFilter ?? xcolor_Foreground), onPressed: widget.onPressedFilterSearch)))),
              ],
            )));
  }
}

class XHeaderWithSorting extends StatefulWidget {
  XHeaderWithSorting({
    Key? key,
    this.title,
    this.label = "",
    this.decoration,
    this.typeUI,
    this.iconContainerWidth,
    this.iconContainerheight,
    this.elevation,
    this.icon,
    this.style,
    this.iconSize,
    this.colorBackgroundHeader = Colors.black,
    this.textColor,
    this.iconColor = Colors.black,
    this.onPressed,
    this.child,
    this.padding,
    this.shape,
    this.flex,
    this.onTap,
    this.listInUI,
    this.heightHeader,
    this.widthHeader,
    this.styleLabel,
    this.colorIcon,
    this.propName,
    this.onTapHeader,
    this.iconChanged,
    this.listForSort,
  }) : super(key: key);
  final String? title;
  final String? label;
  final IconData? icon;
  final Function()? onPressed;
  final Decoration? decoration;
  final TextStyle? style;
  final Color? textColor;
  final Color? iconColor;
  final Color colorBackgroundHeader;
  final Widget? child;
  final double? elevation;
  final EdgeInsetsGeometry? padding;
  final OutlinedBorder? shape;
  final double? iconSize;
  final double? iconContainerWidth;
  final double? iconContainerheight;
  final int? typeUI;
  final int? flex;
  final Function()? onTap;
  final List<dynamic>? listInUI;
  final double? heightHeader;
  final double? widthHeader;
  final TextStyle? styleLabel;
  final Color? colorIcon;
  final String? propName;
  final Function()? onTapHeader;
  late bool? iconChanged;
  final List<dynamic>? listForSort;

  @override
  _XHeaderWithSortingState createState() => _XHeaderWithSortingState();
}

class _XHeaderWithSortingState extends State<XHeaderWithSorting> {
  IconData? sortActive = Icons.expand_less;
  IconData? sortDeactive = Icons.expand_more;
  int? typeOfIcon = 0;
  @override
  void initState() {
    widget.iconChanged = false;
    super.initState();
  }

  sortString(dynamic a, dynamic b, String propName) {
    var resData = a.getProp(propName).compareTo(b.getProp(propName));
    return resData;
  }

  IconData? typeOfIconWidget() {
    if (typeOfIcon == 0) {
      return null;
    } else if (typeOfIcon == 1) {
      return sortActive;
    } else if (typeOfIcon == 2) {
      return sortDeactive;
    }
  }

  onTapForSort() {
    setState(() {
      widget.onTapHeader; // TODO da vedere perche non so come fare il sort a seconda di quale è attivo
      widget.iconChanged = !widget.iconChanged!;
      if (typeOfIcon == 0) {
        typeOfIcon = 1;
      } else if (typeOfIcon == 1) {
        typeOfIcon = 2;
      } else if (typeOfIcon == 2) {
        typeOfIcon = 0;
      }
    });
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
        onTap: onTapForSort,
        child: Container(
            decoration: BoxDecoration(
              border: Border.all(width: 1, color: Colors.black),
              color: widget.colorBackgroundHeader,
            ),
            child: Row(
              mainAxisAlignment: MainAxisAlignment.center,
              children: [
                Container(
                    color: widget.colorBackgroundHeader,
                    height: widget.heightHeader,
                    alignment: Alignment.center,
                    child: Text(
                      widget.label ?? "",
                      style: widget.styleLabel ?? TextStyle(color: xcolor_Foreground),
                    )),
                typeOfIcon != 0 ? Container(child: Icon(typeOfIconWidget(), color: widget.colorIcon)) : Container(),
              ],
            )));
  }
}

class XfxElenco extends StatefulWidget {
  XfxElenco({
    Key? key,
    this.titleElenco = "",
    this.visibleXContainerWithLabelOnTop = true,
    this.headerVisible,
    this.filtersVisible = true,
    this.heightForHeader,
    this.listOfHeader,
    this.listOfFilters,
    this.numberOfHeader,
    this.list,
    this.flexForList,
    this.colorBackgroundContainerElTitle,
    this.heightContainerElTitle,
    this.styleElTitle,
    this.labelBTNOfTitle,
    this.colorBTNOfTitle,
    this.onPressedBTNOfTitle,
    this.heightBTNOfTitle,
    this.widthBTNOfTitle,
    this.visibleBTNofTitle = false,
    this.typeUIBTNofTitle,
    this.marginBTNofTitle,
  }) : super(key: key);
  final String titleElenco;
  final bool visibleXContainerWithLabelOnTop;
  final bool? headerVisible;
  final bool? filtersVisible;
  final double? heightForHeader;
  final List<Widget>? list;
  final List<Widget>? listOfHeader;
  final List<Widget>? listOfFilters;
  final int? numberOfHeader;
  final int? flexForList;
  final Color? colorBackgroundContainerElTitle;
  final double? heightContainerElTitle;
  final TextStyle? styleElTitle;
  final String? labelBTNOfTitle;
  final Color? colorBTNOfTitle;
  final Function()? onPressedBTNOfTitle;
  final double? heightBTNOfTitle;
  final double? widthBTNOfTitle;
  final bool? visibleBTNofTitle;
  final int? typeUIBTNofTitle;
  final EdgeInsets? marginBTNofTitle;
  @override
  _XfxElencoState createState() => _XfxElencoState();
}

class _XfxElencoState extends State<XfxElenco> {
  @override
  Widget build(BuildContext context) {
    return Container(
        margin: EdgeInsets.symmetric(horizontal: 15),
        child: Column(children: [
          SizedBox(height: 10),
          widget.visibleXContainerWithLabelOnTop == true
              ? Row(
                  children: [
                    Expanded(child: XContainerWithLabel(widget.titleElenco, height: widget.heightContainerElTitle ?? 30, color: widget.colorBackgroundContainerElTitle ?? xcolor_BackGroundTitleContainerForElenco, textStyle: widget.styleElTitle ?? TextStyle(fontSize: 18, color: Colors.black))),
                    widget.visibleBTNofTitle == true
                        ? Container(
                            margin: widget.marginBTNofTitle ?? EdgeInsets.only(left: 5),
                            height: widget.heightBTNOfTitle ?? 25,
                            width: widget.widthBTNOfTitle ?? 70,
                            child: XBtnbase(
                              typeUI: widget.typeUIBTNofTitle ?? 2,
                              label: widget.labelBTNOfTitle ?? "Add New",
                              onPressed: widget.onPressedBTNOfTitle,
                              decoration: BoxDecoration(color: widget.colorBTNOfTitle),
                            ),
                          )
                        : Container(),
                  ],
                )
              : Container(),
          SizedBox(height: widget.headerVisible == true ? 3 : 0),
          widget.headerVisible == true ? Row(children: widget.listOfHeader!) : Container(),
          SizedBox(height: widget.headerVisible == true ? 5 : 0),
          widget.filtersVisible == true ? Row(children: widget.listOfFilters!) : Container(),
          SizedBox(height: widget.filtersVisible == true ? 5 : 0),
          Expanded(
            flex: widget.flexForList ?? 18,
            child: ListView(children: widget.list!),
          ),
        ]));
  }
}

class XfxItemForList extends StatefulWidget {
  XfxItemForList({Key? key, this.title = "", this.descr, this.note, this.editable, this.colorBorderReadOnly}) : super(key: key);
  final String title;
  final String? descr;
  final String? note;
  final bool? editable;
  final Color? colorBorderReadOnly;
  @override
  _XfxItemForListState createState() => _XfxItemForListState();
}

class _XfxItemForListState extends State<XfxItemForList> {
  InputBorder? borderStyle() {
    return UnderlineInputBorder(borderRadius: BorderRadius.all(Radius.circular(4.0)), borderSide: BorderSide(width: 1, color: Colors.white));
  }

  @override
  Widget build(BuildContext context) {
    return Row(
      children: [
        Expanded(
            child: Container(
                decoration: BoxDecoration(
                  borderRadius: BorderRadius.all(Radius.circular(10)),
                  color: Colors.grey[850],
                ),
                margin: EdgeInsets.only(
                  bottom: 5,
                ),
                padding: EdgeInsets.only(bottom: 5),
                alignment: Alignment.centerLeft,
                child: Row(children: [
                  Expanded(
                      child: widget.editable == true
                          ? XTextFormField(height: 40, textColor: xcolor_Foreground, initialValue: widget.title, border: borderStyle(), disabledBorder: borderStyle(), enabledBorder: borderStyle())
                          : Container(height: 40, decoration: BoxDecoration(), alignment: Alignment.center, child: Text(widget.title))),
                  Expanded(
                      child: widget.editable == true
                          ? XTextFormField(height: 40, initialValue: widget.descr, border: borderStyle(), disabledBorder: borderStyle(), enabledBorder: borderStyle(), hintStyle: TextStyle(color: xcolor_Foreground))
                          : Container(height: 40, decoration: BoxDecoration(), alignment: Alignment.center, child: Text(widget.descr ?? ""))),
                  Expanded(
                      child: widget.editable == true
                          ? XTextFormField(height: 40, initialValue: widget.note, border: borderStyle(), disabledBorder: borderStyle(), enabledBorder: borderStyle())
                          : Container(height: 40, decoration: BoxDecoration(), alignment: Alignment.center, child: Text(widget.note ?? "")))
                ])))
      ],
    );
  }
}

class XAlertDialog extends StatelessWidget {
  String? titleText;
  Function()? onPressedYes;
  Function()? onPressedNo;
  String? labelBTNyes;
  String? labelBTNno;
  Color? colorYes;
  Color? colorNo;
  Widget? childOfAlert;
  double? heightAlertDialog;
  XAlertDialog({
    this.titleText,
    this.onPressedYes,
    this.onPressedNo,
    this.labelBTNyes,
    this.heightAlertDialog,
    this.labelBTNno,
    this.colorYes,
    this.colorNo,
    this.childOfAlert,
  });

  @override
  Widget build(BuildContext context) {
    return AlertDialog(
        backgroundColor: Colors.grey[800],
        title: Container(
            height: heightAlertDialog ?? 400,
            child: Column(
              children: [Text(titleText ?? 'Hai cambiato dei dati cosa vuoi fare?', style: TextStyle(color: Colors.white, fontSize: 19)), childOfAlert != null ? Container(child: childOfAlert) : Container(height: 1)],
            )),
        content: Row(mainAxisAlignment: MainAxisAlignment.spaceAround, children: [
          Expanded(child: Container(child: TextButton(onPressed: onPressedNo, child: Text(labelBTNno ?? "NON LI CONFERMO", style: TextStyle(color: colorNo ?? Colors.redAccent))))),
          Expanded(child: Container(child: TextButton(onPressed: onPressedYes, child: Text(labelBTNyes ?? "LI CONFERMO", style: TextStyle(color: colorYes ?? Colors.greenAccent))))),
        ]));
  }
}
